using System;
using System.Linq;
using System.Collections.Generic;

class Solution {
  public static void Main(string[] args) {
    int n = int.Parse(Console.ReadLine());
    
    List<List<int>> groups = new();
    for(int i = 0; i < n; i++) groups.Add(new());

    for(int i = 0; i < n; i++)
    {
      var r = i + 1;
      var r1 = r * 2;
      var r2 = r1 > n ? r1 - n : r1;

      groups[i].Add(r);
      groups[i].Add(r2);
    }
    
    for(int i = 0; i < groups.Count; i++)
    {
      var currentGroup = groups[i];
      var appendGroup = 
        groups.Find(g => currentGroup.Any(n => g.Any(n2 => n == n2)) && g != currentGroup);

      if(appendGroup is null) continue;

      groups.Remove(appendGroup);
      currentGroup.AddRange(appendGroup);
      i--;
    }
    
    var success = groups.Count == 1;
    if(success)
    {
      Console.WriteLine("YES");
      return;
    }
    
    Console.WriteLine("NO");
    var num1 = groups.First().First();
    var num2 = groups.Last().First();

    Console.WriteLine($"{num1} {num2}");
  }
}
