#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, x1, y1, x2, y2;
    cin >> n >> x1 >> y1 >> x2 >> y2;

    vector<pair<int, int>> copouls(n);
    for (int i = 0; i < n; i++)
        cin >> copouls[i].first >> copouls[i].second;

    vector<pair<bool, bool>> inside(n);

    for (int i = 0; i < n; i++)
    {
        int dist1 = (x1 - copouls[i].first) * (x1 - copouls[i].first) + y1 * y1;
        int dist2 = (x2 - copouls[i].first) * (x2 - copouls[i].first) + y2 * y2;

        if (dist1 <= copouls[i].second * copouls[i].second)
            inside[i].first = true;
        if (dist2 <= copouls[i].second * copouls[i].second)
            inside[i].second = true;
    }

    bool isInside = true;
    int index = 0;
    for (int i = 0; i < n; i++)
    {
        if (!inside[i].first == inside[i].second)
        {
            isInside = false;
            index = i;
            break;
        }
    }

    if (isInside)
    {
        cout << "YES";
        return 0;
    }

    cout << "NO" << endl
         << index + 1;
}
