#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> rects;
map<pair<int, int>, bool> visited;

bool dfs(int x, int y, int n, int m, int k)
{
    if (x == n && y == m)
        return true;
    if (x < 0 || x > n || y < 0 || y > m)
        return false;
    for (int i = 0; i < k; i++)
    {
        int x1 = rects[i][0], y1 = rects[i][1];
        int x2 = rects[i][2], y2 = rects[i][3];
        if (x - 0.5 >= x1 && x - 0.5 <= x2 && y >= y1 && y <= y2)
            return false;
        if (x + 0.5 >= x1 && x + 0.5 <= x2 && y >= y1 && y <= y2)
            return false;
        if (x >= x1 && x <= x2 && y - 0.5 >= y1 && y - 0.5 <= y2)
            return false;
        if (x >= x1 && x <= x2 && y + 0.5 >= y1 && y + 0.5 <= y2)
            return false;
    }

    if (visited[{x, y}])
        return false;
    visited[{x, y}] = true;

    bool result = dfs(x - 0.5, y, n, m, k) || dfs(x + 0.5, y, n, m, k) || dfs(x, y - 0.5, n, m, k) || dfs(x, y + 0.5, n, m, k);
    return result;
}

int main()
{
    int n, m, k;
    cin >> n >> m >> k;
    rects.resize(k, vector<int>(4));
    for (int i = 0; i < k; i++)
        cin >> rects[i][0] >> rects[i][1] >> rects[i][2] >> rects[i][3];

    if (dfs(0, 0, n, m, k))
        cout << "YES" << endl;
    else
        cout << "NO" << endl;

    return 0;
}
