#include <bits/stdc++.h>
using namespace std;

int n;
vector<vector<int>> graph;

void check_connectivity() {
    vector<bool> visited(n);
    queue<int> q;
    q.push(0);
    visited[0] = true;

    while (!q.empty()) {
        for (int i = 0; i < graph[q.front()].size(); i++) {
            if (!visited[graph[q.front()][i]]) {
                q.push(graph[q.front()][i]);
                visited[graph[q.front()][i]] = true;
            }
        }

        q.pop();
    }

    bool t = false;
    for (int i = 0; i < n; i++) {
        if (!visited[i]) {
            cout << "NO" << endl << 1 << " " << i + 1;
            t = true;
            break;
        }
    }

    if (!t) cout << "YES";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	cin>>n;
    graph.resize(n);

    for (int i = 0; i < n; i++) {
        int next_ind = (i+1)*2;
        if (next_ind > n) {
            next_ind -= n;
        }
        graph[i].push_back(next_ind - 1);
        graph[next_ind - 1].push_back(i);
    }

    check_connectivity();
}
