#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,popcnt,bmi,bmi2,abm")

#include <bits/stdc++.h>

using namespace std;

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//template<class T> using oset=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
//template<class T> using omultiset=tree<T,null_type,less_equal<T>,rb_tree_tag,tree_order_statistics_node_update>;

#define sz(x) (int)(x).size()
#define int long long
#define rep(i,l,r) for(int i=l;i<=(r);++i)
#define repd(i,r,l) for(int i=r;i>=(l);--i)
#define pb push_back
#define x first
#define y second
#define lb lower_bound
#define ub upper_bound
#define all(x) x.begin(),x.end()
#define ins insert
#define show(x) cout<<(#x)<<" : "<<x<<'\n'

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int,int>pii;
typedef pair<ll,ll>pll;
typedef vector<ll>vll;
typedef vector<int>vi;
typedef vector<bool>vb;
typedef vector<vi>vvi;
typedef vector<vll>vvll;
typedef vector<pii>vpii;
typedef vector<pll>vpll;

template<class T> bool umin(T& a,const T& b){return b<a ? a=b,1:0;}
template<class T> bool umax(T& a,const T& b){return a<b ? a=b,1:0;}

const int N=1e6+5;
const int mod=1e9+7;
const ll infe18=1e18;
const int infe9=1e9+9;
const char nl='\n';

int pr[N];
int sz[N];

int get(int x){
    return x==pr[x] ? x : pr[x]=get(pr[x]);
}

void unite(int x,int y){
    x=get(x);
    y=get(y);
    if(x!=y){
        if(sz[x]<sz[y]){
            swap(x,y);
        }
        pr[y]=x;
        sz[x]+=sz[y];
    }
}

bool adj(pair<pii,pii> rect1,pair<pii,pii> rect2){
    auto [x1,y1]=rect1.x;
    auto [x2,y2]=rect1.y;
    auto [x3,y3]=rect2.x;
    auto [x4,y4]=rect2.y;
    if(x1>x3){
        swap(x1,x3),swap(y1,y3);
        swap(x2,x4),swap(y2,y4);
    }
    if(y1==y4 && x3>=x1 && x3<=x2) return 1;
    if(x2==x3 && y3>=y1 && y3<=y2) return 1;
    if(y2==y3 && x3<=x2 && x3>=x1) return 1;
    return 0;
}

void solve(){
    int n,m,k;
    cin>>n>>m>>k;
    vector<pair<pii,pii>> rect(k);
    for(int i=0;i<k;++i){
        pr[i]=i;
        sz[i]=1;
    }
    for(int i=0;i<k;++i){
        cin>>rect[i].x.x>>rect[i].x.y>>rect[i].y.x>>rect[i].y.y;
    }
    for(int i=0;i<k-1;++i){
        for(int j=i+1;j<k;++j){
            if(adj(rect[i],rect[j])){
                unite(i,j);
//                cout<<i<<' '<<j<<nl;
            }
        }
    }
    for(int i=0;i<k;++i){
        if((rect[i].x.x==0 && rect[i].y.x==n) || (rect[i].x.y==0 && rect[i].y.y==m)){
            cout<<"NO";
            return;
        }
        for(int j=0;j<k;++j){
            if(i==j || get(i)!=get(j)) continue;
            if((rect[i].x.y==0 || rect[i].y.x==n) && (rect[j].x.x==0 || rect[j].y.y==m)){
                cout<<"NO";
                return;
            }
        }
    }
    cout<<"YES";
}

/**

**/

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t=1;
//    cin>>t;
    while(t--){
        solve();
    }
}
