function search(cities) {
	let map = [ 1 ];
	cities[1].connected = true;
	
	while ( map.length > 0 ) {
		let i = map.shift();
		cities[i].roads.forEach((neighbourI) => {
			if (!cities[neighbourI].connected) {
				cities[neighbourI].connected = true;
				map.push(neighbourI);
			}
		});
	}
}

process.stdin.on('data', function (data) {
  const n = parseInt(data, 10)
  let cities = [];

  for (var i = 1; i <= n; i++) {
  	if (!cities[i])
  		cities[i] = { roads: [], connected: false };

  	if (i+i > n && i+i-n !== n) {
  		cities[i+i-n] = cities[i+i-n] || { roads: [], connected: false };
  		cities[i].roads.push(i+i-n);
  		cities[i+i-n].roads.push(i);
  	} else if (i+i <= n) {
  		cities[i+i] = { roads: [], connected: false };
  		cities[i].roads.push(i+i);
  		cities[i+i].roads.push(i);
  	}
  }

  search(cities);
  const notConnected = cities.findIndex(c => c && c.connected === false);
  notConnected === -1
  	? console.log('YES')
  	: console.log('NO\n'+1+' '+notConnected);
});
