#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    size_t n;
    cin >> n;
    vector<int> arr(n, 0);
    for (int i = 0; i < n; i++)
    {
        cin >> arr[i];
    }

    uint64_t max_weight = 0;
    for (size_t i = 0; i < (n - 1); i++)
    {
        int min1 = arr[i];
        int min2 = 2147483647;
        size_t max_len = n - i;
        size_t next_step = 0;
        for (size_t len = 2; len <= max_len; len++)
        {
            int new_elem = arr[i + len - 1];
            bool found_new_min = false;
            if (new_elem < min1)
            {
                int temp = min1;
                min1 = new_elem;
                min2 = temp;
                found_new_min = true;
            }
            else if (new_elem < min2)
            {
                min2 = new_elem;
                found_new_min = true;
            }

            if (found_new_min)
            {
                uint64_t unit = (uint64_t)min1 + min2;
                uint64_t max_possible_weight = unit * max_len;
                int64_t difference = max_possible_weight - max_weight;
                if (difference <= 0)
                {
                    break;
                }
                else
                {
                    next_step = max(0LL, (int64_t)(max_weight / unit + 1) - (int64_t)len);
                }
            }

            if (next_step)
            {
                next_step--;
            }
            else
            {
                uint64_t new_weight = ((uint64_t)min1 + min2) * len;
                if (new_weight > max_weight)
                {
                    max_weight = new_weight;
                }
            }
        }
    }

    std::cout << max_weight << endl;
}