#include <bits/stdc++.h>
using namespace std;

const int K=5000;

int n, m, k;
vector<int> i1(K+1, INT_MAX), J1(K+1, INT_MAX), i2(K+1, INT_MAX), j2(K+1, INT_MAX);
vector<vector<int> > g(K+1);
vector<bool> vis(K+1);
queue<int> q;

bool intersect(int i, int j)
{
    bool res=1;
    if(J1[i]>j2[j]){
        res=0;
    }
    if(J1[j]>j2[i]){
        res=0;
    }
    if(i1[i]>i2[j]){
        res=0;
    }
    if(i1[j]>i2[i]){
        res=0;
    }
    return res;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> k;
    for(int i=1; i<=k; i++){
        cin >> i1[i] >> J1[i] >> i2[i] >> j2[i];
    }
    for(int i=1; i<=k; i++){
        for(int j=i+1; j<=k; j++){
            if(intersect(i, j)){
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for(int i=1; i<=k; i++){
        if(i1[i]==0){
            g[0].push_back(i);
        }
    }
    q.push(0);
    while(!q.empty()){
        int v=q.front();
        q.pop();
        if(i2[v]==n){
            cout << "NO";
            return 0;
        }
        for(int u: g[v]){
            if(!vis[u]){
                vis[u]=1;
                q.push(u);
            }
        }
    }
    g[0].clear();
    for(int i=1; i<=k; i++){
        if(J1[i]==0){
            g[0].push_back(i);
        }
    }
    vis.assign(k+1, 0);
    q.push(0);
    while(!q.empty()){
        int v=q.front();
        q.pop();
        if(j2[v]==m){
            cout << "NO";
            return 0;
        }
        for(int u: g[v]){
            if(!vis[u]){
                vis[u]=1;
                q.push(u);
            }
        }
    }
    g[0].clear();
    for(int i=1; i<=k; i++){
        if(i2[i]==n){
            g[0].push_back(i);
        }
    }
    vis.assign(k+1, 0);
    q.push(0);
    while(!q.empty()){
        int v=q.front();
        q.pop();
        if(j2[v]==m){
            cout << "NO";
            return 0;
        }
        for(int u: g[v]){
            if(!vis[u]){
                vis[u]=1;
                q.push(u);
            }
        }
    }
    g[0].clear();
    for(int i=1; i<=k; i++){
        if(i1[i]==0){
            g[0].push_back(i);
        }
    }
    vis.assign(k+1, 0);
    q.push(0);
    while(!q.empty()){
        int v=q.front();
        q.pop();
        if(J1[v]==0){
            cout << "NO";
            return 0;
        }
        for(int u: g[v]){
            if(!vis[u]){
                vis[u]=1;
                q.push(u);
            }
        }
    }
    cout << "YES";
}
