import math

n, dog_x, dog_y, bee_x, bee_y = map(int, input().split())

grid = [["." for _ in range(30)] for _ in range(10)]
dog_x, dog_y, bee_x, bee_y = dog_x*3, -dog_y-2, bee_x*3, -bee_y-2

circles = []

for i in range(n):
    circles.append(tuple(map(int, input().split())))

grid[dog_y][dog_x] = 'D'
grid[bee_y][bee_x] = 'B'

def is_dog_in_danger(grid, d_x, d_y, b_x, b_y):
    # x, y
    # d_x, d_y, b_x, b_y = -d_x, -d_y, -b_x, -b_y
    d_x, d_y, b_x, b_y = d_x, len(grid)+d_y, b_x, len(grid) + bee_y
    dirs = [(0, -1), (0, 1), (1, 0), (-1, 0)]
    current = (b_x, b_y)
    to_check = [(b_x, b_y)]
    while to_check:
        cell_to_check = to_check.pop(0)

        for direction_x, direction_y in dirs:
            if 0 <= direction_x + cell_to_check[0] <= len(grid[0])-1 and 0 <= direction_y + cell_to_check[1] <= len(grid)-1:
                if grid[direction_y + cell_to_check[1]][direction_x + cell_to_check[0]] in ['.', 'B', 'D']:
                    to_check.append((direction_x + cell_to_check[0], direction_y + cell_to_check[1]))
                    grid[direction_y + cell_to_check[1]][direction_x + cell_to_check[0]] = '!'
            else:
                continue

    if grid[d_y][d_x] == '!':
        return True
    return False


for circ_i in range(len(circles)):
    center = (circles[circ_i][0]*3, len(grid)-1)
    r = circles[circ_i][1] * 3

    for i in range(0, 181, 10):
        angle = i

        # print(f"i = {i} {i < 90}")
        if i <= 90:
            x = int(math.cos(math.radians(angle)) * r)
            y = int(math.sin(math.radians(angle)) * r)
            grid[center[1]-y][center[0]-x] = 'W'
        else:
            x = int(math.cos(math.radians(180 - angle)) * r)
            y = int(math.sin(math.radians(180 - angle)) * r)
            grid[center[1]-y][center[0]+x] = 'W'

can_bee_hit_the_dog = is_dog_in_danger(grid, dog_x, dog_y, bee_x, bee_y)
if can_bee_hit_the_dog:
    print("YES")
else:
    print("NO")

# x = int(math.cos(math.radians(70)) * r)
# y = int(math.sin(math.radians(70)) * r)

# print(x, y)

# grid[center[1]-y][center[0]-x] = 'W'
for row in grid:
    for sym in row:
        print(sym, end='')
    print()

# print(x)
# print(y)
