#include"bits/stdc++.h"
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi,bmi2,abm,popcnt")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) begin(x),end(x)

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

// #libs:libs

bool onLocal(){
    #ifdef LIS05ST
        return 1;
    #endif
    return 0;
}

void precalc(){

}

const int NMAX=1e6;
int a[NMAX+5];

ll solve(int l,int r){
    if(l>=r){
        return 0;
    };
    int m=min_element(a+l,a+r+1)-a;
    ll ans=max(solve(l,m-1),solve(m+1,r));
    int L=m-1;int R=m+1;
    int mnL=1e9+1;int mnR=1e9+1;
    for(;L>=l;L--){
        mnL=min(mnL,a[L]);
        while(R<=r){
            if(min(mnR,a[R])<mnL)break;
            mnR=min(mnR,a[R]);
            R++;
        }
        ans=max(ans,1ll*(mnL+a[m])*(R-L));
    }
    L=m-1;R=m+1;
    mnL=1e9+1;mnR=1e9+1;
    for(;R<=r;R++){
        mnR=min(mnR,a[R]);
        while(l<=L){
            if(min(mnL,a[L])<mnR)break;
            mnL=min(mnL,a[L]);
            L--;
        }
        ans=max(ans,1ll*(mnR+a[m])*(R-L));
    }
    return ans;
}


#define MULTITESTS 0
void solve(int testCase){

    rng.seed(9999);
    int n;cin>>n;
    for(int i=0;i<n;i++)cin>>a[i];
    cout<<solve(0,n-1)<<"\n";
}

const char* INPUT_FILE="/home/lis05st/CPv2/files/input.txt";
const char* OUTPUT_FILE="/home/lis05st/CPv2/files/output.txt";

signed main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

    if(onLocal()){
        freopen(INPUT_FILE,"r",stdin);
        freopen(OUTPUT_FILE,"w",stdout);

        time_t end_time=
        chrono::system_clock::to_time_t(chrono::system_clock::now());
    
        cout<<"Ran on "<<std::ctime(&end_time);
        cout<<"==================================\n";
    }

    precalc();
    int t=1;
    if(MULTITESTS)cin>>t;
    for(int i=1;i<=t;i++){
        auto t1=clock();
        solve(i);
        auto t2=clock();
        float delta=t2-t1;
        delta/=CLOCKS_PER_SEC;
        if(onLocal()){
            cout<<"("<<i<<")------------"<<fixed<<setprecision(2)<<delta<<"s\n";
        }
    }
}



