#include"bits/stdc++.h"
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi,bmi2,abm,popcnt,lzcnt")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) begin(x),end(x)

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

// #libs:libs

bool onLocal(){
    #ifdef LIS05ST
        return 1;
    #endif
    return 0;
}

void precalc(){

}

const int NMAX=1e6;
int a[NMAX+5];

const int LOG=20;
int table[LOG][NMAX+5];

int get(int l,int r){
    if(r<l)return 1e9+1;
    int len=r-l+1;
    int lg=31-__builtin_clz(len);
    return min(table[lg][l],table[lg][r-(1<<lg)+1]);
}

ll solve(int l,int r){
    if(l>=r){
        return 0;
    };
    int m=min_element(a+l,a+r+1)-a;
    ll ans=0;
    if(1||m-l>r-m){
        // left is good
        int mn=1e9+1;
        for(int i=m-1;i>=l;i--){
            mn=min(mn,a[i]);
            int L=m;int R=r+1;
            while(R>L+1){
                int mid=(L+R)/2;
                if(get(m+1,mid)>=mn)L=mid;
                else R=mid;
            }
            ans=max(ans,1ll*(mn+a[m])*(L-i+1));
        }

        // if we've already counted the whole right part
        if(get(m+1,r)>=mn)return max({ans,solve(l,m-1),solve(m+1,r)});
        int mnR=get(m+1,r);
        ans=max(ans,1ll*(a[m]+mnR)*(r-l+1));
        int last=r;
        while(true){
            int L=m;int R=last;
            while(R>L+1){
                int mid=(L+R)/2;
                if(get(m+1,mid)<=mnR)R=mid;
                else L=mid;
            }
            if(L==m)break;
            mnR=get(m+1,L);
            if(mnR>mn)break;
            ans=max(ans,1ll*(a[m]+mnR)*(L-l+1));
            last=r;
        }
        return max({ans,solve(l,m-1),solve(m+1,r)});
    }
}


#define MULTITESTS 0
void solve(int testCase){

    rng.seed(9999);
    int n=1e6;
    cin>>n;
    for(int i=0;i<n;i++)a[i]=rng()%int(1e9)+1,cin>>a[i];
    for(int i=0;i<n;i++)table[0][i]=a[i];
    for(int lvl=1;lvl<LOG;lvl++){
        int len=1<<lvl;
        int half=len>>1;
        for(int i=0;i<n;i++){
            if(i+len-1>=n)break;
            table[lvl][i]=min(table[lvl-1][i],table[lvl-1][i+half]);
        }
    }
    
    //for(int i=0;i<n;i++)for(int ii=i;ii<n;ii++)if(get(i,ii)!=*min_element(a+i,a+ii+1))exit(1);

    cout<<solve(0,n-1)<<"\n";
}

const char* INPUT_FILE="/home/lis05st/CPv2/files/input.txt";
const char* OUTPUT_FILE="/home/lis05st/CPv2/files/output.txt";

signed main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

    if(onLocal()){
        freopen(INPUT_FILE,"r",stdin);
        freopen(OUTPUT_FILE,"w",stdout);

        time_t end_time=
        chrono::system_clock::to_time_t(chrono::system_clock::now());
    
        cout<<"Ran on "<<std::ctime(&end_time);
        cout<<"==================================\n";
    }

    precalc();
    int t=1;
    if(MULTITESTS)cin>>t;
    for(int i=1;i<=t;i++){
        auto t1=clock();
        solve(i);
        auto t2=clock();
        float delta=t2-t1;
        delta/=CLOCKS_PER_SEC;
        if(onLocal()){
            cout<<"("<<i<<")------------"<<fixed<<setprecision(2)<<delta<<"s\n";
        }
    }
}



