import math

n, x1, y1, x2, y2 = map(int, input().split())
domes = [list(map(int, input().split())) for _ in range(n)]

safe = False
closest_dome = None
min_dist = 0

for i, (pos, r) in enumerate(domes):
    dist = math.sqrt((x1 - pos)**2 + y1**2)
    dist_bjoli = math.sqrt((x2 - pos)**2 + y2**2)
    if dist <= r and dist_bjoli > r:
        safe = True
        break
    else:
        if dist - r < min_dist:
            min_dist = dist - r
            closest_dome = i + 1

if not safe:
    print("YES")
else:
    print("NO")
    print(closest_dome)
