def gcc(graph, n): 
    def dfs(current_node, component): 
        visited[current_node] = 1
        queue = [current_node]
        while queue:
            current_node = queue.pop(0)
            for u, v in graph:
                if u == current_node and not visited[v]:
                    component.add(v)
                    queue.append(v)
                    visited[v] = 1
                if v == current_node and not visited[u]:
                    component.add(u)
                    queue.append(u)
                    visited[u] = 1
 
    visited = [0 for _ in range(n)]
    components = []
    
    for a in range(n):
        if not visited[a]:
            component = set([a])
            dfs(a, component)
            components.append(sorted(list(component)))
    
    return components
 
                
n = int(input())
roads=[]
for i in range(1,n):
    roads.append(( i,(i+i)%n ))
gd = gcc(roads,n)
components = gcc(roads, n)

if len(components) == 1:
    print("YES")
else:
    print("NO")
    print(components[0][-1] + 1, components[1][-1] + 1)
