from heapq import heapify, heappop

def max_subarray_price(n, a):
    max_price = -float('inf')
    for i in range(n-1):
        for j in range(i+1, n):
            subarray = a[i:j+1]
            min_heap = subarray[:]
            heapify(min_heap)
            min1 = heappop(min_heap)
            min2 = heappop(min_heap)
            price = (j-i+1) * (min1 + min2)
            max_price = max(max_price, price)
    return max_price




n = int(input())
a = list(map(int, input().split()))
print(max_subarray_price(n, a))
