#include <iostream>
#include <vector>
#include <algorithm>

int max_subarray_price(int n, std::vector<int> a) {
    std::vector<int> price;
    for (int i = 0; i < n-1; i++) {
        for (int j = i+1; j < n; j++) {
            std::vector<int> subarray(a.begin() + i, a.begin() + j + 1);
            int min1 = *std::min_element(subarray.begin(), subarray.end());
            subarray.erase(std::remove(subarray.begin(), subarray.end(), min1), subarray.end());
            int min2 = *std::min_element(subarray.begin(), subarray.end());
            int subarray_price = (min1 + min2) * (j-i+1);
            price.push_back(subarray_price);
        }
    }
    return *std::max_element(price.begin(), price.end());
}

int main() {
    int n;
    std::cin >> n;
    std::vector<int> a(n);
    for (int i = 0; i < n; i++) {
        std::cin >> a[i];
    }
    std::cout << max_subarray_price(n, a) << std::endl;
    return 0;
}
