#include <bits/stdc++.h>

#define fr first
#define sc second
#define pb push_back

using namespace std;
typedef long long ll;
typedef string str;
typedef pair<ll, ll> pll;
typedef pair<pll, pll> ppp;
const ll MAXNUM = 5007;

ll sizee[MAXNUM], par[MAXNUM], problem;
ll n, m, k;
ppp rect[MAXNUM], coner[MAXNUM];
bool impos = 0;

ll parent(ll a){
    if(par[a]==a) return a;
    else return par[a] = parent(par[a]);
}

void unite(ll a, ll b){
    a = parent(a); b = parent(b);
    if(a == b) return;
    if(sizee[a]<sizee[b]) swap(a,b);
    sizee[a]+=sizee[b];
    par[b]=a;
    coner[a] = {{min(coner[a].fr.fr, coner[b].fr.fr), min(coner[a].fr.sc, coner[b].fr.sc)}, {max(coner[a].sc.fr, coner[b].sc.fr), max(coner[a].sc.sc, coner[b].sc.sc)}};
    if((coner[a].fr.fr==0 && coner[a].fr.sc==0) || (coner[a].fr.fr==0 && coner[a].sc.fr==n) || (coner[a].fr.sc==0 && coner[a].sc.sc==m) || (coner[a].sc.fr==n && coner[a].sc.sc==m)) impos=1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	cin >> n >> m >> k;
    for(int i=1; i<=k; i++){
        cin >> rect[i].fr.fr >> rect[i].fr.sc >> rect[i].sc.fr >> rect[i].sc.sc;
        coner[i]=rect[i];
        sizee[i]=1;
        par[i]=i;
    }

    for(int i=1; i<=k; i++){
        if((rect[i].fr.fr==0 && rect[i].fr.sc==0) || (rect[i].fr.fr==0 && rect[i].sc.fr==n) || (rect[i].fr.sc==0 && rect[i].sc.sc==m) || (rect[i].sc.fr==n && rect[i].sc.sc==m)) impos=1;
        for(int j=i+1; j<=k; j++){
            if(rect[i].fr.fr>rect[j].sc.fr || rect[i].sc.fr<rect[j].fr.fr || rect[i].fr.sc>rect[j].sc.sc || rect[i].sc.sc<rect[j].fr.sc) continue;
            unite(i, j);
            if(impos) break;
        }
        if(impos) break;
    }
    if(impos) cout << "NO";
    else cout << "YES";
}
