#include <bits/stdc++.h>

#define fr first
#define sc second
#define pb push_back

using namespace std;
typedef long long ll;
typedef string str;
typedef pair<ll, ll> pll;
typedef pair<pll, pll> ppp;
const ll MAXNUM = 1000007, INF=100000007;

ll n, m, k, p, a[MAXNUM];
pll TL[MAXNUM*4];

pll unite(pll b1, pll b2, ll tl,ll tm,ll tr){
    vector<ll> res;
    if(tl==tm) res.pb(b1.fr);
    else {res.pb(b1.fr); res.pb(b1.sc);}
    if(tr==tm+1) res.pb(b2.fr);
    else {res.pb(b2.fr); res.pb(b2.sc);}
    sort(res.begin(), res.end());
    return {res[0], res[1]};
}

void build(ll v,ll tl,ll tr){
    if(tl==tr) {TL[v] = {a[tl], a[tl]}; return;}
    ll tm = (tl+tr)/2;
    build(v*2+1, tl, tm);
    build(v*2+2, tm+1, tr);
    TL[v] = unite(TL[2*v+1], TL[2*v+2], tl, tm, tr);
}

pll findMin(ll v,ll tl,ll tr,ll l,ll r){
    if(tl>r || tr<l) return {INF, INF};
    if(tl>=l && tr<=r) return TL[v];

    ll tm = (tl+tr)/2;
    return unite(findMin(2*v+1, tl, tm, l, r), findMin(2*v+2, tm+1, tr, l, r), tl, tm, tr);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	cin >> n;
    for(int i=1; i<=n; i++) cin >> a[i];
    build(0, 1, n);
    ll ma=0;
    pll mi;
    for(int i=1; i<=n; i++){
        for(int j=i+1; j<=n; j++){
            mi = findMin(0, 1, n, i, j);
            if(ma<(j-i+1)*(mi.fr+mi.sc)) ma = (j-i+1)*(mi.fr+mi.sc);
        }
    }
    cout << ma;
    return 0;
}
