#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
typedef long long ll;
struct dsu
{
    int n;
    vector < int > p, w, maxx, minx, maxy, miny;
    dsu(int nn)
    {
        n = nn;
        p.resize(n);
        w.resize(n, 1);
		maxx.resize(n, - 1);
		miny.resize(n, 1e9);
		maxy.resize(n, - 1);
		minx.resize(n, 1e9);
        for (int i = 0; i <= n; ++i)
            p[i] = i;
    }
    int leader(int v) {
        return (p[v] == v) ? v : p[v] = leader(p[v]);
    }
    void unite(int a, int b)
    {
        a = leader(a), b = leader(b);
        if(a != b)
        {
            if(w[a] > w[b])
                swap(a, b);
            p[a] = b;
            w[b] += w[a];
			maxx[b] = max(maxx[b], maxx[a]);
			maxy[b] = max(maxy[b], maxy[a]);
			minx[b] = min(minx[b], minx[a]);
			miny[b] = min(miny[b], miny[a]);
        }
    }
};
bool intersec(array < int, 4 > & a, array < int, 4 > & b) {
	return a[0] <= b[2] && b[0] <= a[2] && a[1] <= b[3] && b[1] <= a[3];
}
void solve()
{
	ll n, m, k;
	cin >> n >> m >> k;
	vector < array < int, 4 >> rect(k);
	dsu d(k);
	for(int i = 0; i < k; ++i) {
		cin >> rect[i][0] >> rect[i][1] >> rect[i][2] >> rect[i][3];
		d.maxx[i] = max(rect[i][0], rect[i][2]);
		d.minx[i] = min(rect[i][0], rect[i][2]);
		d.maxy[i] = max(rect[i][1], rect[i][3]);
		d.miny[i] = min(rect[i][1], rect[i][3]);
	}
	for (int i = 0; i < k; ++i)
		for (int j = 0; j < k; ++j) 
			if(intersec(rect[i], rect[j]))
				d.unite(i, j);
	for (int i = 0; i < n; ++i) {
		if(d.maxx[i] == n && d.minx[i] == 0 || d.maxy[i] == m && d.miny[i] == 0) {
			cout << "NO\n";
			return;
		}
	}
	cout << "YES\n";
	
}
signed main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	ll q = 1;
	while (q--)
		solve();
	return 0;
}
