#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
typedef long long ll;
struct SegTree {
    ll n;
    vector < pair < ll, ll >> t;
    SegTree(ll nn) {
        n = 1 << ((ll)ceil(log2(nn)));
        t.resize(n << 1, {1e10, 1});
    }
    void build() {
        for (ll i = n - 1; i > 0; --i)
            t[i] = min(t[i << 1], t[i << 1 | 1]);
    }
    pair < ll, ll > res(ll l, ll r) {
		++r;
		pair < ll, ll > ans = {1e10, 1};
		for(l += n, r += n; l < r; l >>= 1, r >>= 1) {
			if(l & 1)
				ans = min(ans, t[l++]);
			if(r & 1)
				ans = min(ans, t[--r]);
		}
		return ans;
   	} 
};

ll findval(ll l, ll r, vector < ll > & a, SegTree & t) {	
	if(r <= l)
		return 0;
	if(r - l <= 1)
		return 2 * (a[l] + a[r]);
	int i = t.res(l, r).second;
	int j = t.res(l, i - 1).first > t.res(i + 1, r).first ? t.res(i + 1, r).second : t.res(l, i - 1).second;

	if(i < j)
		swap(i, j);
	return max({(r - l + 1) * (a[i] + a[j]), findval(l, j, a, t), findval(j, i - 1, a, t), findval(j + 1, i, a, t), findval(i, r, a, t)});
}

void solve()
{
	ll n;
	cin >> n;
	vector < ll > a(n);
	for(auto & i : a)
	cin >> i;
	SegTree t(n);
	for (int i = 0; i < n; ++i) {
		t.t[t.n + i] = {a[i], i};
	}
	t.build();
	cout << findval(0, n - 1, a, t);

}
signed main()
{
	cin.tie(0);
	ios_base::sync_with_stdio(false);
	ll q = 1;
	while (q--)
		solve();
	return 0;
}
