#include <bits/stdc++.h>
using namespace std;
const int Nmax = 1e4;

struct vertex
{
    long long x = 0;
    long long y = 0;
};
char table[Nmax][Nmax], empty_point = '.', box_point='*', step = '1';
vertex up, down;
int n, m, k;



int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);



    cin >> n >> m >> k;

    for(int j = 1; j <= n; j++)
        for(int k = 1; k <= m; k++)
            table[j][k] = empty_point;
    for(int i = 0; i <= n+1; i++)
    {
        table[i][0] = box_point;
        table[i][m + 1] = box_point;
    }
    for(int i = 0; i <= m+1; i++)
    {
        table[0][i] = box_point;
        table[n + 1][i] = box_point;
    }
    for(int i = 0; i < k; i++)
    {
        cin >> up.x >> up.y >> down.x >> down.y;

        for(int j = up.x+1; j <= down.x; j++)
        {
            for(int k = up.y+1; k <= down.y; k++)
            {
                table[j][k] = box_point;
            }
        }
    }

    table[n][m] = step;

    vertex cur;
    cur.x = n;
    cur.y = m;

    vertex Queue[Nmax], moves[100], next;
    int head = 0, tail = 1;
    Queue[head] = cur;
    moves[0]= {1,0};
    moves[1]= {0,-1};
    moves[2]= {-1,0};
    moves[3]= {0,1};

    while (head < tail)
    {
        cur = Queue[head];
        //cout << cur.x << " " << cur.y << "\n";
        for (int i = 0; i < 4; i++)
        {
            next.x = cur.x + moves[i].x;
            next.y = cur.y + moves[i].y;
            if (table[next.x][next.y] == empty_point && next.x != 0 && next.y != 0)
            {
                table[next.x][next.y] = step;
                Queue[tail] = next;
                tail++;                
            }
        }
        head++;
    }
    
    if(table[1][1] == step) cout << "YES\n";
    else cout << "NO\n";
}
