using System;
using System.Collections.Generic;
using System.Linq;

var len = int.Parse(Console.ReadLine());
var arr = Console.ReadLine().Split(' ').Select(int.Parse).ToArray();

IEnumerable<ArraySegment<int>> ComposeSubArrays(int[] arr) {
    for(int i = 0; i < arr.Length - 1; i++){
        for(int j = i + 1; j < arr.Length; j++)
            yield return new ArraySegment<int>( arr, i, j - i + 1);
    }
}


int GetCost(ArraySegment<int> arr) {
    var a = Math.Min(arr.Array[arr.Offset], arr.Array[arr.Offset + 1]);
    var b = Math.Max(arr.Array[arr.Offset], arr.Array[arr.Offset + 1]);
    foreach(var i in arr)
        if (i <= a){
            b = a;
            a = i;
            }
        else if (i <= b) {
            b = i;
            }
    
    return (a + b) * arr.Count;
}

var max = 0;
foreach(var sub in ComposeSubArrays(arr))
    max  = Math.Max(max, GetCost(sub));
Console.WriteLine(max);  
