#include <bits/stdc++.h>
using namespace std;

struct P
{
    int x1;
    int y1;
    int x2;
    int y2;
    int ind;
};

bool check(P p1, P p2)
{
    return (((p1.x1<=p2.x2 && p1.x1>=p2.x1) || (p1.x2<=p2.x2 && p1.x2>=p2.x1)) && ((p1.y1<=p2.y2 && p1.y1>=p2.y1) || (p1.y2<=p2.y2 && p1.y2>=p2.y1)));
}

bool cmp1(const P &a, const P &b)
{
    return (a.x1>b.x1) || (a.x1==b.x1 && (a.y1>b.y1));
}

bool cmp2(const P &a, const P &b)
{
    return (a.y1>b.y1) || (a.y1==b.y1 && (a.x1>b.x1));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, m, k;
	cin>>n>>m>>k;
    vector<P> ar(k);
    for (int i=0;i<k;++i) {
        cin>>ar[i].x1>>ar[i].y1>>ar[i].x2>>ar[i].y2;
        ar[i].ind = i;
    }
    vector<list<int>> cross(k);
    for (int i=0;i<k-1;++i) {
        for (int j=i+1;j<k;++j) {
            if (check(ar[i], ar[j])) {
                cross[i].push_back(j);
                cross[j].push_back(i);
            }
        }
    }
    if (k==1) {
        if ((ar[0].x1 == 0 && ar[0].x2 == n) || (ar[0].y1 == 0 && ar[0].y2 == m)) cout<<"NO\n";
        else cout<<"YES\n";
    } else {
        bool flag = true;
        for (int i=0;i<k && flag;++i) {
            if (ar[i].x1 == 0 || ar[i].y1 == 0) {
                vector<int> q(k), tick(n, 0);
                q[0] = i;
                tick[i] = 1;
                int s = 1;
                while (s && flag) {
                    --s;
                    int x = q[s];
                    for (auto itr=cross[x].begin();itr!=cross[x].end() && flag;++itr) {
                        if (!tick[(*itr)]) {
                            if ((!ar[i].x1 && ar[(*itr)].x2 == n) || (!ar[i].y1 && ar[(*itr)].y2 == m)) flag = false;
                            else {
                                tick[(*itr)] = 1;
                                q[s] = (*itr);
                                ++s;
                            }
                        }
                    }
                }
            }
        }
        if (flag) cout<<"YES\n";
        else cout<<"NO\n";
    }
}
