#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>

#define LF '\n'

using namespace std;
typedef long long int lli;

vector<int> used;

void dfs(int a, int n)
{
    if (used[a] != 0)return;
    used[a] = 1;
    int to = (2 * a);
    if (to > n)to -= n;
    dfs(to, n);
    to = (a + n) / 2;
    if ((a + n) % 2 == 0) {
        dfs(to, n);
    }
}

void solve()
{
    int n;
    cin >> n;
    used.resize(n + 1, 0);
    dfs(1, n);
    for (int i = 1; i <= n; i++) {
        if (used[i] == 0) {
            cout << "NO" << LF << "1 " << i;
            return;
        }
    }
    cout << "YES";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif


    solve();
}

