#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <math.h>
#include <queue>
#include <string>
#include <iomanip>
#include <set>
#include <cmath>
#include<stack>

#define LF '\n'

using namespace std;
typedef long long int lli;

vector<lli> v;
stack<int> st;
stack<int> t;
vector<int> minl1;
vector<int> minl2;
vector<int> minr1;
vector<int> minr2;
vector<int> used;

void cntminr(int n)
{
    while (!st.empty())st.pop();
    while (!t.empty())t.pop();
    for (int i = 1; i <= n; i++)used[i] = 0;
    for (int i = 1; i <= n; i++) {
        while (!st.empty()) {
            int ind = st.top();
            if (v[i] <= v[ind]) {
                t.push(ind);
                st.pop();
                used[ind]++;
            }
            else break;
        }
        st.push(i);
        while (!t.empty()) {
            int ind = t.top();
            t.pop();
            if (v[i] == v[ind]) {
                if (used[ind] == 1) {
                    minr1[ind] = i;
                }
                else {
                    used[ind] = 1;
                }
                st.push(ind);
            }
            else {
                if (used[ind] == 1) {
                    st.push(ind);
                    minr1[ind] = i;
                }
                else {
                    minr2[ind] = i;
                }
            }
        }
    }

}

void cntminl(int n)
{
    while (!st.empty())st.pop();
    while (!t.empty())t.pop();
    for (int i = 1; i <= n; i++)used[i] = 0;
    for (int i = n; i >= 1; i--) {
        while (!st.empty()) {
            int ind = st.top();
            if (v[i] <= v[ind]) {
                t.push(ind);
                st.pop();
                used[ind]++;
            }
            else break;
        }
        st.push(i);
        while (!t.empty()) {
            int ind = t.top();
            t.pop();
            if (v[i] == v[ind]) {
                if (used[ind] == 1) {
                    minl1[ind] = i;
                }
                else {
                    used[ind] = 1;
                }
                st.push(ind);
            }
            else {
                if (used[ind] == 1) {
                    st.push(ind);
                    minl1[ind] = i;
                }
                else {
                    minl2[ind] = i;
                }
            }
        }
    }

}

lli cntresr(int i, int n)
{
    lli res1 = 0;
    lli l = 0;
    if (minr2[i] != -1) {
        l = minr2[i] - i;
    }
    else {
        l = n - i + 1;
    }
    if (minl1[i] != -1) {
        l += (i - minl1[i] - 1);
    }
    else {
        l += (i - 1);
    }
    if (minr1[i] == -1)res1 = 0;
    else res1 = (v[i] + v[minr1[i]]) * l;
    return res1;
}

lli cntresl(int i,int n)
{
    lli res1 = 0;
    lli l = 0;
    if (minl2[i] != -1) {
        l = i - minl2[i];
    }
    else {
        l = i;
    }
    if (minr1[i] != -1) {
        l += (minr1[i] - i - 1);
    }
    else {
        l += (n-i);
    }
    if (minl1[i] == -1)res1 = 0;
    else res1 = (v[i] + v[minl1[i]]) * l;
    return res1;
}

void solve()
{
    int n;
    cin >> n;
    v.resize(n + 1);
    minl1.resize(n + 1, -1);
    minl2.resize(n + 1, -1);
    minr1.resize(n + 1, -1);
    minr2.resize(n + 1, -1);
    used.resize(n + 1, 0);
    for (int i = 1; i <= n; i++)cin >> v[i];
  
    cntminr(n);
    cntminl(n);
    lli ans = 0;
    for (int i = 1; i <= n; i++) {
        lli res1=cntresr(i,n);
        lli res2 = cntresl(i,n);
        lli res = max(res1, res2);
        ans = max(ans, res);
    }
    cout << ans;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    solve();
}

