#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a.size())
//#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;
using vppi = vector<ppi>;
using ull=unsigned long long;

vl sz, parent;
ll findParent(ll v){
    if(v == parent[v]) return v;
    return parent[v] = findParent(parent[v]);
}
void unite(ll a, ll b){
    a=findParent(a);
    b=findParent(b);
    if(a!=b){
        if(sz[a]<sz[b]) swap(a, b);
        sz[a]+=sz[b];
        parent[b]=a;
    }
}

void solve()
{
    int n;
    cin>>n;
    sz.rs(n+1);
    parent.rs(n+1);
    for(int i=1;i<=n;i++){
        sz[i]=1;
        parent[i]=i;
    }
    for(int i=1;i<=n;i++){
        ll nxt=i+i;
        if(nxt>n) nxt-=n;
        unite(i, nxt);
    }
    int ans=1, tp=-1;
    for(int i=2;i<=n;i++){
        if(findParent(1)!=findParent(i)){
            tp=i;
            ans=0;
            break;
        }
    }
    if(ans){
        cout<<"YES"<<endl;
    }
    else{
        cout<<"NO"<<endl;
        cout<<1<<" "<<tp<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
   // cin>>t;
    while (t--)
        solve();

}
/*

*/
