n, m, k = map(int, input().split())
rectangles = [list(map(int, input().split())) for _ in range(k)]


blocked = set()
for x1, y1, x2, y2 in rectangles:
    for i in range(x1, x2+1):
        for j in range(y1, y2+1):
            blocked.add((i, j))


q = [(0, 0)]
visited = set()
while q:
    x, y = q.pop(0)
    if (x, y) in blocked or (x, y) in visited:
        continue
    visited.add((x, y))
    if x == n and y == m:
        print("YES")
        exit()
    for dx, dy in [(0.5, 0), (-0.5, 0), (0, 0.5), (0, -0.5)]:
        new_x, new_y = x + dx, y + dy
        if 0 <= new_x <= n and 0 <= new_y <= m:
            q.append((new_x, new_y))

print("NO")