<?php
    function quickSort($arr) {
        $length = count($arr);

        if($length <= 1)
            return $arr;
        
        $baseValue = $arr[0];
        $leftArr = $rightArr = array();
    
        for ($i = 1; $i < $length; $i++){
            if($baseValue > $arr[$i])
                $leftArr[] = $arr[$i];
            else
                $rightArr[] = $arr[$i];
        }
    
        $leftArr = quickSort($leftArr);
        $rightArr = quickSort($rightArr);
        
        return array_merge($leftArr, array($baseValue), $rightArr);
    }

    $n = readline('');
    $nums = readline('');
    $nums = explode(' ', $nums);
    $length = count($nums);
    $nums = quickSort($nums);

    $res = 2 * ($nums[$length - 2] + $nums[$length - 1]);
    echo $res;
?>