#include <bits/stdc++.h>
using namespace std;

bool is_intersect(double a, double b, double c, double d, double p, double q, double r, double s) {
    double det = (c - a) * (s - q) - (r - p) * (d - b);
    if (det == 0) return false;
    double x = ((s - q) * (r - a) + (p - r) * (s - b)) / det;
    double y = ((c - a) * (s - b) + (d - b) * (r - a)) / det;
    return (x >= 0 && x <= 1) && (y >= 0 && y <= 1);
}

int main() {
    int n, m, k;
    cin >> n >> m >> k;
    bool flag = true;
    while (k--) {
        double x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        if (is_intersect(0, 0, n, m, x1, y1, x2, y2) ||
            is_intersect(0, 0, m, n, y1, x1, y2, x2) ||
            is_intersect(0, m, n, 0, x1, y2, x2, y1)) {
            flag = false;
            break;
        }
    }
    cout << (flag ? "YES" : "NO") << endl;
    return 0;
}
