#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,popcnt,bmi,bmi2,abm")

#include <bits/stdc++.h>

using namespace std;

//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//template<class T> using oset=tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;
//template<class T> using omultiset=tree<T,null_type,less_equal<T>,rb_tree_tag,tree_order_statistics_node_update>;

#define sz(x) (int)(x).size()
#define int long long
#define rep(i,l,r) for(int i=l;i<=(r);++i)
#define repd(i,r,l) for(int i=r;i>=(l);--i)
#define pb push_back
#define x first
#define y second
#define lb lower_bound
#define ub upper_bound
#define all(x) x.begin(),x.end()
#define ins insert
#define show(x) cout<<(#x)<<" : "<<x<<'\n'

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef pair<int,int>pii;
typedef pair<ll,ll>pll;
typedef vector<ll>vll;
typedef vector<int>vi;
typedef vector<bool>vb;
typedef vector<vi>vvi;
typedef vector<vll>vvll;
typedef vector<pii>vpii;
typedef vector<pll>vpll;

template<class T> bool umin(T& a,const T& b){return b<a ? a=b,1:0;}
template<class T> bool umax(T& a,const T& b){return a<b ? a=b,1:0;}

const int N=2e5+5;
const int mod=1e9+7;
const ll infe18=1e18;
const int infe9=1e9+9;
const char nl='\n';

int a[N];
vpii v;

int ternarka(int S,int mn,int l,int r){
    while(r-l>3){
        int mid1=l+(r-l)/3;
        int mid2=r-(r-l)/3;
        int f1=(mn-v[mid1].x)*(S+v[mid1].y);
        int f2=(mn-v[mid2].x)*(S+v[mid2].y);
        if(f1<f2){
            l=mid1;
        }
        else{
            r=mid2;
        }
    }
    int mx=0;
    for(int i=l;i<=r;++i){
        umax(mx,(mn-v[i].x)*(S+v[i].y));
    }
    return mx;
}

int solve(int l,int r){
    if(r-l<=0){
        return 0;
    }
    if(r-l==1){
        return (a[l]+a[r])*2;
    }

    int mid=l+r>>1;

    v.clear();
    int mn=a[mid+1];
    for(int i=mid+1;i<=r;++i){
        umin(mn,a[i]);
        if(i==r || a[i+1]<mn){
            v.pb({-mn,i-mid});
        }
    }
    v.pb({0,0});
//    for(auto [i,j]:v) cout<<i<<' '<<j<<nl;
    int mn1,mn2,mn3;
    mn1=mn2=mn3=infe9;
    int res=0;
    for(int i=mid;i>=l;--i){
        if(a[i]<mn1){
            mn3=mn2;
            mn2=mn1;
            mn1=a[i];
        }
        else if(a[i]<mn2){
            mn3=mn2;
            mn2=a[i];
        }
        else if(a[i]<mn3){
            mn3=a[i];
        }
        int S=mid-i+1;
        auto it=lb(all(v),make_pair(-mn1,0ll));
        if(it->x){
            int l_=it-v.begin();
            int r_;
            if(it->x==-mn1){
                r_=lb(all(v),make_pair(-mn1+1,0ll))-v.begin();
            }
            else{
                r_=lb(all(v),make_pair(-mn1,it->y+1))-v.begin();
            }
            umax(res,ternarka(S,mn1,l_,r_));
        }
        if(mn2>mn1){
            auto it_=lb(all(v),make_pair(-mn2,0ll));
            if(it_->x){
                int l_=it_-v.begin();
                int r_=it-v.begin()-1;
                if(l_>=0 && r_>=0 && l_<=r_){
                    umax(res,ternarka(S,mn1,l_,r_));
                }
            }
        }
    }

    v.clear();
    mn=a[mid];
    for(int i=mid;i>=l;--i){
        umin(mn,a[i]);
        if(i==l || a[i-1]<mn){
            v.pb({-mn,mid-i+1});
        }
    }
    v.pb({0,0});
//    for(auto [i,j]:v) cout<<i<<' '<<j<<nl;
    mn1=mn2=mn3=infe9;
    for(int i=mid+1;i<=r;++i){
        if(a[i]<mn1){
            mn3=mn2;
            mn2=mn1;
            mn1=a[i];
        }
        else if(a[i]<mn2){
            mn3=mn2;
            mn2=a[i];
        }
        else if(a[i]<mn3){
            mn3=a[i];
        }
        int S=i-mid;
        auto it=lb(all(v),make_pair(-mn1,0ll));
        if(it->x){
            int r_=it-v.begin();
            int l_;
            if(it->x==-mn1){
                l_=lb(all(v),make_pair(-mn1+1,0ll))-v.begin();
            }
            else{
                l_=lb(all(v),make_pair(-mn1,it->y+1))-v.begin();
            }
//            cout<<l_<<' '<<r_<<' '<<mn1<<' '<<S<<nl;
            umax(res,ternarka(S,mn1,l_,r_));
        }
        if(mn2>mn1){
            auto it_=lb(all(v),make_pair(-mn2,0ll));
            if(it_->x){
                int r_=it_-v.begin();
                int l_=it-v.begin()-1;
                if(l_>=0 && r_>=0 && l_<=r_){
                    umax(res,ternarka(S,mn1,l_,r_));
                }
            }
        }
    }
    umax(res,solve(l,mid));
    umax(res,solve(mid+1,r));
    return res;
}

/**

**/

int32_t main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin>>n;
    for(int i=1;i<=n;++i){
        cin>>a[i];
    }
    if(n<=2e4+5){
        int mn1=infe9,mn2=infe9;
        ll ans=0;
        for(int i=1;i<n;++i){
            mn1=mn2=infe9;
            mn1=a[i];
            for(int j=i+1;j<=n;++j){
                if(a[j]<mn1){
                    mn2=mn1;
                    mn1=a[j];
                }
                else if(a[j]<mn2){
                    mn2=a[j];
                }
                umax(ans,1ll*(j-i+1)*(mn1+mn2));
            }
        }
        cout<<ans;
        exit(0);
    }
    cout<<solve(1,n);
}
