#include <iostream>
#include <vector>

using namespace std;
vector<int> graph[100000];
bool used[100000];
vector<int> comp;

void dfs(int v) {
    used[v] = true;
    comp.push_back(v);
    for (int i = 0; i < graph[v].size(); ++i) {
        int a = graph[v][i];
        if (!used[a])
            dfs(a);
    }
}

int main() {
    int n;
    cin >> n;
    int cnt = 0;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        x--, y--;

        graph[x].push_back(y);
        graph[y].push_back(x);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs(i), cnt++;
            cout << cnt << ": ";
            for (auto it: comp) {
                cout << it + 1 << ' ';
            }
            cout << endl;
        }
        comp.resize(0);
    }
}