#include <bits/stdc++.h>
using namespace std;

struct Tree
{
    int index;
    bool visited = false;
    vector<Tree*> children;
};

bool found[1000001]{ false };

void recursive_visit(Tree* node)
{
    node->visited = true;
    found[node->index] = true;
    for (Tree* child : node->children)
    {
        if (!child->visited)
        {
            recursive_visit(child);
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    Tree** node_lookup = new Tree*[1000001] {0};
    for (int i = 1; i <= n; i++)
    {
        int j = i * 2;
        if (j > n)
        {
            j -= n;
        }

        if (!node_lookup[i])
        {
            node_lookup[i] = new Tree{ i };
        }
        if (!node_lookup[j])
        {
            node_lookup[j] = new Tree{ j };
        }
        node_lookup[i]->children.push_back(node_lookup[j]);
        node_lookup[j]->children.push_back(node_lookup[i]);
    }

    recursive_visit(node_lookup[1]);
    int disconnected_index = 0;
    for (int i = 1; i <= n; i++)
    {
        if (!found[i])
        {
            disconnected_index = i;
            break;
        }
    }

    if (disconnected_index == 0)
    {
        cout << "YES" << endl;
    }
    else
    {
        cout << "NO" << endl;
        cout << 1 << " " << disconnected_index << endl;
    }
}