#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    ll n;
    cin >> n;
    vector<ll> sv;
    for (ll i = 0; i < n; i++)
    {
        ll inp; cin >> inp;
        sv.push_back(inp);
    }
    vector<ll> v;
    if (n > 2000)
    {
        v.push_back(sv[0]);
        v.push_back(sv[1]);
        for (int i = 2; i < n - 1000; i++)
        {
            if (!(sv[i - 2] < sv[i - 1] && sv[i - 1] < sv[i] && sv[i] < sv[i + 1] && sv[i + 1] < sv[i + 2])) v.push_back(sv[i]);
            else v.push_back(-1);
        }
        for (int i = n - 1000; i < n; i++)
        {
            v.push_back(sv[i]);
        }
    }
    else
    {
        v = sv;
    }
    ll min1, min2;
    vector<ll> vp(n, 0);
    ll res = 0;
    for (ll c = 0; c < n - 1; c++)
    {
        if (v[c] != -1)
        {
            min1 = v[c]; min2 = LONG_MAX;
            for (ll i = c + 1; i < n; i++)
            {
                if (v[i] != -1)
                {
                    if (v[i] <= min1)
                    {
                        min2 = min1;
                        min1 = v[i];
                    }
                    else if (v[i] < min2) min2 = v[i];
                    res = max(res, (i - c + 1) * (min1 + min2));
                    if (min1 + min2 > vp[i])
                    {
                        vp[i] = min1 + min2;
                    }
                    else break;
                }
            }
        }
    }
    cout << res;
}