#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> graph;
int n; 
map<int, bool> vis;

void bfs(int s){
    queue<int> q;
    q.push(s);
    vis[s] = true;
    while (!q.empty()){
        int u = q.front(); q.pop();
        for (int i: graph[u]){
            if (!vis[i]){
                q.push(i);
                vis[i] = true;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    for (int i = 0; i <= n; i++){
        graph.push_back({});
    }
    for (int i = 1; i <= n; i++){
        int u = 2*i;
        if (u > n){
            u -= n;
        }
        graph[i].push_back(u);
        graph[u].push_back(i);
    }
    bfs(1);
    for (int i = 2; i <= n; i++){
        if (!vis[i]){
            cout<<"NO"<<endl;
            cout<<1<<" "<<i<<endl;
            return 0;
        }
    }
    cout<<"YES"<<endl;
}