from heapq import heapify, heappop

def max_subarray_price(n, a):
    max_price = -float('inf')
    for i in range(n-1):
        for j in range(i+1, n):
            subarray = a[i:j+1]
            min1 = min(subarray)
            subarray.remove(min1)
            min2 = min(subarray)
            subarray_price = (min1 + min2) * (j-i+1)
            max_price = max(max_price, subarray_price)
    return max_price



n = int(input())
a = list(map(int, input().split()))
print(max_subarray_price(n, a))
