#include <bits/stdc++.h>
using namespace std;

struct coord{
    int x;
    int y;
};

void input(long long mas[][1000], int n, int m){
    for (int i = 1; i <= n; i++)
        for(int j = 1; j <= m; ++j)
            mas[i][j] = 0;
    for(int i = 0; i <= m + 1; ++i)
        mas[0][i] = -1;
    for(int i = 0; i <= n + 1; ++i)
        mas[i][0] = -1;
    for(int i = 0; i <= n + 1; ++i)
        mas[i][m + 1] = -1;
    for(int i = 0; i <= m + 1; ++i)
        mas[n + 1][i] = -1;
}

void way(long long mas[][1000], int n, int m, coord &pos_start){
    int step[4][2] = {{1, 0}, {0, 1}, {-1, 0}, {0, -1}};
    coord queue[100000];
    int head = 0, tail = 1;
    queue[0].x = pos_start.x;
    queue[0].y = pos_start.y;
    int current_x = queue[head].x, current_y = queue[head].y;
    while(head < tail){
        current_x = queue[head].x;
        current_y = queue[head].y;
        for(int i = 0; i < 4; ++i){
            if (mas[current_y + step[i][0]][current_x + step[i][1]] == 0){
                queue[tail].x = current_x + step[i][1];
                queue[tail].y = current_y + step[i][0];
                mas[current_y + step[i][0]][current_x + step[i][1]] = mas[current_y][current_x] + 1;
                ++tail;
            }
        }
        ++head;
    }
}

void output_mas(long long mas[][1000], int n, int m){
    for(int i = 0; i <= n + 1; ++i){
        for(int j = 0; j <= m + 1; ++j)
            cout << mas[i][j] << " ";
        cout << "\n";
    }
}

long long mas[1000][1000];
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    coord start, finish;
    coord pos_start, pos_last;
    int n, cnt = 0, m, k;
    cin >> m >> n >> k;
    input(mas, n, m);
    for (int i = 0; i < k; ++i){
        cin >> start.x >> start.y >> finish.x >> finish.y;
        for (int j = start.x + 1; j < finish.x + 1; ++j)
            for (int h = start.y + 1; h < finish.y + 1; ++h)
                mas[h][j] = -1;
    }
    mas[1][1] = 1;
    pos_start.y = 1;
    pos_start.x = 1;
    way(mas, n, m, pos_start);
    //output_mas(mas, n, m);
    if (mas[n][m] == 0) cout << "NO";
    else cout << "YES";
}
