#include <bits/stdc++.h>
using namespace std;
const int Nmax = 1e6;
vector <int>graph[Nmax];
bool used[Nmax];

void dfs (int i)
{
    //cout << i << "+";
    used[i] = true;
    for(auto j = graph[i].begin(); j < graph[i].end(); j++)
    {
        if(!used[*j]) dfs(*j);
    }
    

}

void all_trip(int n)
{
    for(int i = 1; i <= n; i++)
    {
        if(!used[i]) dfs(i); 
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	long long  n;
	cin>>n;
    int id_2 = 0;
    for(int i = 1; i <= n; i++)
    {
        id_2 = 2*i;
        if(id_2 > n) id_2 -= n;
        graph[i].push_back(id_2);
        graph[id_2].push_back(i);
    }
    dfs(1);
    int i = 1;
    while(i <= n && used[i])
        i++;
    if(i == n + 1) cout << "YES\n";
    else cout << "NO\n" << "1" << " " << i << "\n";
}
