def check(n, m, k, coordinates):
    visited = set()
    start = (0, 0)
    end = (n, m)

    queue = [start]
    while queue:
        curr = queue.pop(0)
        if curr == end:
            return True
        if curr in visited:
            continue
        visited.add(curr)

        x, y = curr
        valid_moves = []
        if x - 0.5 >= 0 and (x - 0.5, y) not in coordinates:
            valid_moves.append((x - 0.5, y))
        if x + 0.5 <= n and (x + 0.5, y) not in coordinates:
            valid_moves.append((x + 0.5, y))
        if y - 0.5 >= 0 and (x, y - 0.5) not in coordinates:
            valid_moves.append((x, y - 0.5))
        if y + 0.5 <= m and (x, y + 0.5) not in coordinates:
            valid_moves.append((x, y + 0.5))

        queue.extend(valid_moves)

    return False

n, m, k = input().split()
n = int(n)
m = int(m)
k = int(k)
coordinates = []
while n>=1:
    user_input = input("")
    my_tuple = tuple(int(item) for item in user_input.split())
    coordinates.append(my_tuple)
    n-=1
if check(n, m, k, coordinates):
    print("YES")
else:
    print("NO")