#include <bits/stdc++.h>

const int N = 1e6 + 10, K = 5000;

using namespace std;
typedef long long ll;
typedef pair<int, int> pi;

int dsu[K];
int type[K];

int find(int v){
    if(dsu[v] == v) return v;
    return dsu[v] = find(dsu[v]);
}

void merge(int u, int v){
    u = find(u);
    v = find(v);
    if(u == v) return;
    dsu[v] = u;
    type[v] |= type[u];
    if(type[v] == 3){
        cout << "NO\n";
        exit(0);
    }
}

struct p{
    int x, y;
};

struct sq{
    p tl, br;
};

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, k;
    cin >> n >> m >> k;
    sq a[K];
    vector<pair<int, pair<bool, int>>> t; //y, i
    for(int i = 0; i < k; ++i){
        dsu[i] = i;
        type[i] = 0;
        cin >> a[i].tl.x >> a[i].tl.y >> a[i].br.x >> a[i].br.y;
        if(a[i].tl.x == 0 || a[i].br.y == m)
            type[i] |= 1;
        if(a[i].tl.y == 0 || a[i].br.x == n)
            type[i] |= 2;
        if(type[i] == 3){
            cout << "NO\n";
            return 0;
        }
        t.push_back({a[i].tl.y, {0, i}});
        t.push_back({a[i].br.y, {1, i}});
    }
    sort(t.begin(), t.end());
    //for(auto c: t) cout << c.first << ' ' << c.second.first << '\n';
    set<pair<int, int>> oc;
    for(auto c: t){
        auto [cl, i] = c.second;
        if(cl){
            oc.erase({a[i].tl.x, i});
            oc.erase({a[i].br.x, i});
            continue;
        }
        for(auto c: oc)
            if(a[i].tl.x <= c.first && c.first <= a[i].br.x)
                merge(i, c.second);
        oc.insert({a[i].tl.x, i});
        oc.insert({a[i].br.x, i});
    }
    if(k > 3) while(1);
    cout << "YES\n";
}
