#include <bits/stdc++.h>
using namespace std;

void subsetsUtil(vector<int>& A, vector<vector<int> >& res,
                 vector<int>& subset, int index)
{
    res.push_back(subset);
    for (int i = index; i < A.size(); i++) {
        subset.push_back(A[i]);
        subsetsUtil(A, res, subset, i + 1);
        subset.pop_back();
    }
    return;
}

vector<vector<int>> subsets(vector<int>& A)
{
    vector<int> subset;
    vector<vector<int> > res;
    int index = 0;
    subsetsUtil(A, res, subset, index);
    return res;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int max = 0;
	int n;
    cin>>n;
    vector<int> set(n);
    for(int i = 0; i < n; i++)
    {
        cin>>set[i];
    }
    vector<vector<int>> resultingSubs = subsets(set);
    int size = resultingSubs.size();
    for(int i = 0; i < size; i++)
    {
        if(resultingSubs[i].size()>=2)
        {
            int minSum = 0;
            sort(resultingSubs[i].begin(), resultingSubs[i].end());
            minSum+=resultingSubs[i][0];
            resultingSubs[i].erase(resultingSubs[i].begin());
            minSum+=resultingSubs[i][0];
            resultingSubs[i].erase(resultingSubs[i].begin());
            minSum=resultingSubs[i].size()*minSum;
            if (minSum>max)
            {
                max = minSum;
            }
        }
    }
    cout<<max;
}
