#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
using namespace std;

int main()
{
    int n = 0, m = 0, k = 0;
    cin >> n >> m >> k;
    vector<vector<pair<int, int>>> v;
    vector<vector<pair<int, int>>> g;

    for(int i = 0; i < m; ++i)
    {
        vector<pair<int,int>> l = {};
        v.push_back(l);
    }
    for(int i = 0; i < n; ++i)
    {
        vector<pair<int,int>> l = {};
        g.push_back(l);
    }

    for(int i = 0; i < k; ++i)
    {
        int x1 = 0, y1 = 0, x2 = 0, y2 = 0;
        cin >> x1 >> y1 >> x2 >> y2;
        pair <int, int> p1;
        p1.first = x1;
        p1.second = x2 - 1;
        pair <int, int> p2;
        p2.first = y1;
        p2.second = y2 - 1;
        for(int j = y1; j < y2; ++j)
        {
            v[j].push_back(p1);
        }
        for(int j = x1; j < x2; ++j)
        {
            g[j].push_back(p2);
        }
    }
    for(int i = 0; i < m; ++i)
    {
        if(v[i].empty())
        {
            continue;
        }
        sort(v[i].begin(), v[i].end());
        int r = v[i][0].second;
        bool po = true;
        for(int j = 1; j < v[i].size(); ++j)
        {
            if(v[i][j].first > r)
            {
                po = false;
                break;
            }
            else
            {
                r = max(r, v[i][j].second);
            }
        }
        if(r != n - 1 || v[i][0].first != 0)
        {
            po = false;
        }
        if(po)
        {
            cout << "NO";
            return 0;
        }
    }
    for(int i = 0; i < n; ++i)
    {
        if(g[i].empty())
        {
            continue;
        }
        sort(g[i].begin(), g[i].end());
        int r = g[i][0].second;
        bool po = true;
        for(int j = 1; j < g[i].size(); ++j)
        {
            if(g[i][j].first > r)
            {
                po = false;
                break;
            }
            else
            {
                r = max(r, g[i][j].second);
            }
        }
        if(r != n - 1 || g[i][0].first != 0)
        {
            po = false;
        }
        if(po)
        {
            cout << "NO";
            return 0;
        }
    }
    cout << "YES";
}