#pragma GCC optimize("O3,inline-loops")
#pragma GCC target("avx,avx2,sse4,bmi,bmi2,popcnt,tune=native")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef long double ld;
mt19937 rnd(time(0));
constexpr ll mod = 998244353;
pair<int,int> sgt[4000007];
pair<int,int> mnv(pair<int,int> a,pair<int,int> b){
    if(a.first <= b.first) return {a.first,min(a.second,b.first)};
    else return {b.first,min(b.second,a.first)};
}
pair<int,int> mxv(pair<int,int> a,pair<int,int> b){
    if(a.first >= b.first) return {a.first,max(a.second,b.first)};
    else return {b.first,max(b.second,a.first)};
}
void update_min(int v,int l,int r,int t,int val){
    if(r < t or t < l) return;
    if(l == r){
        sgt[v].second = min(sgt[v].second,val);
        if(sgt[v].first > sgt[v].second) swap(sgt[v].first,sgt[v].second);
        return;
    }
    int m = (l+r)/2;
    update_min(v<<1,l,m,t,val);
    update_min(v<<1|1,m+1,r,t,val);
    sgt[v] = mnv(sgt[v<<1],sgt[v<<1|1]);
}
void update_max(int v,int l,int r,int t,int val){
    if(r < t or t < l) return;
    if(l == r){
        sgt[v].second = max(sgt[v].second,val);
        if(sgt[v].first < sgt[v].second) swap(sgt[v].first,sgt[v].second);
        return;
    }
    int m = (l+r)/2;
    update_max(v<<1,l,m,t,val);
    update_max(v<<1|1,m+1,r,t,val);
    sgt[v] = mxv(sgt[v<<1],sgt[v<<1|1]);
}
int n;
pair<int,int> getmn(int v,int l,int r,int tl,int tr){
    if(r < tl or tr < l) return {n,n};
    if(tl <= l and r <= tr) return sgt[v];
    int m = (l+r)/2;
    return mnv(getmn(v<<1,l,m,tl,tr),getmn(v<<1|1,m+1,r,tl,tr));
}
pair<int,int> getmx(int v,int l,int r,int tl,int tr){
    if(r < tl or tr < l) return {-1,-1};
    if(tl <= l and r <= tr) return sgt[v];
    int m = (l+r)/2;
    return mxv(getmx(v<<1,l,m,tl,tr),getmx(v<<1|1,m+1,r,tl,tr));
}
vector<int> g[1000007];
int a[1000007];
int b[1000007];
pair<int,int> prv[1000007];
pair<int,int> nxt[1000007];
int pr_s[1000007];
int nx_s[1000007];
ll stpuid(int r){
    ll best2 = 0;
    for (int i = 0; i < r; ++i) {
        ll mn1 = a[i];
        ll mn2 = a[i+1];
        if(mn2 < mn1) swap(mn1,mn2);
        best2 = max(best2,(mn1+mn2)*(2));
        for (int j = i+2; j <= r; ++j) {
            mn2 = min(mn2,(ll)a[j]);
            if(mn2 < mn1) swap(mn1,mn2);
            best2 = max(best2,(mn1+mn2)*(j-i+1));
        }
    }
    return best2;
}
inline void solve(){
    cin >> n;
    tree<int,null_type,less<>,rb_tree_tag,tree_order_statistics_node_update> sset;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        sset.insert(a[i]);
        nxt[i] = {n,n};
        prv[i] = {-1,-1};
    }
    for (int i = 0; i < 4*n; ++i) {
        sgt[i] = {-1,-1};
    }
    for (int i = 0; i < n; ++i) {
        b[i] = sset.order_of_key(a[i]);
        if(b[i] != 0)
            prv[i] = getmx(1,0,sset.size()-1,0,b[i]-1);
        if(g[b[i]].size()) pr_s[i] = g[b].back();
        else pr_s[i] = -1;
        g[b[i]].push_back(i);
        update_max(1,0,sset.size()-1,b[i],i);
    }

    for (int i = 0; i < 4*n; ++i) {
        sgt[i] = {n,n};
    }
    for (int i = 0; i < sset.size(); ++i) {
        g[i].clear();
    }
    for (int i = n-1; i >= 0; --i) {
        if(b[i] != 0) nxt[i] = getmn(1,0,sset.size()-1,0,b[i]-1);
        if(g[b[i]].size()) nx_s[i] = g[b].back();
        else nx_s[i] = n;
        g[b[i]].push_back(i);
        update_min(1,0,sset.size()-1,b[i],i);
    }
    //for (int i = 0; i < n; ++i) {
        //cout << prv[i].second << " " << prv[i].first << "    " << i << "    " << nxt[i].first << " " << nxt[i].second << "\n";
   // }
    ll ans = 0;
    for (int i = 0; i < n; ++i) {
        ll mx2 = a[i];
        if(prv[i].first != -1){
            ll mx1 = a[prv[i].first];
            ll l = prv[i].second+1;
            ll r = nxt[i].first-1;
            ans = max(ans,(mx1+mx2)*(r-l+1));
        }
        if(nxt[i].first != n){
            ll mx1 = a[nxt[i].first];
            ll l = prv[i].first+1;
            ll r = nxt[i].second-1;
            ans = max(ans,(mx1+mx2)*(r-l+1));
        }
        if(pr_s[i] != -1){
            ll l = prv[i].first+1;
            ll r = nxt[i].first-1;
            if(l <= pr_s[i]) ans = max(ans,2*mx2*(r-l+1));
        }
        if(nx_s[i] != 1){
            ll l = prv[i].first+1;
            ll r = nxt[i].first-1;
            if(nx_s[i] <= r) ans = max(ans,2*mx2*(r-l+1));
        }
    }
    cout << ans << "\n";
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
/*
5
3 10 10 2 4

 */