using System;
using System.Linq;

public class Program
{
    public static void Main(string[] args)
    {   
        var n = int.Parse(Console.ReadLine());


        ConnectedNodes[] connectedNodes = new ConnectedNodes[n];

        for (int i = 0; i < n; i++)
        {
            var city = i + 1;

            connectedNodes[i] = new ConnectedNodes(new int[] {city });
        }

        for (int i = 0; i < n; i++)
        {
            var city = i + 1;
            var connectedCity = GetNextCity(city, n);

            var cityNodes = ConnectedNodes.FindNodeWithArray(connectedNodes[city - 1]);
            var nextCityNodes = ConnectedNodes.FindNodeWithArray(connectedNodes[connectedCity - 1]);

            if (cityNodes.ID != nextCityNodes.ID)
            {
                int[] newArrary = new int[0]; // MergeArrays(cityNodes.Nodes, nextCityNodes.Nodes);
                var node = new ConnectedNodes(newArrary);
                //todo: delete array
                cityNodes.NodeReference = node;
                nextCityNodes.NodeReference = node;

            }
        }


        var firstConnectedNodes = ConnectedNodes.FindNodeWithArray(connectedNodes[0]);

        for (int i = 1; i < n; i++)
        {
            var nextConnectedNodes = ConnectedNodes.FindNodeWithArray(connectedNodes[i]);
            if (firstConnectedNodes.ID != nextConnectedNodes.ID)
            {
                Console.WriteLine("NO");
                Console.WriteLine($"{1} {i + 1}");
                return;
            }
        }
       
        Console.WriteLine("YES");
    }
    
    public static int[] MergeArrays(int[] a1, int[] a2) 
    { 
        return a1.Union(a2).ToArray<int>();
    }

    public static int GetNextCity(int i, int n)
    {
        return (2 * i > n) ? 2 * i - n : 2 * i;
    }

    public class ConnectedNodes
    {
        public string ID;
        public int[] Nodes;
        public ConnectedNodes NodeReference;

        public ConnectedNodes(int[] nodes) 
        { 
            ID = Guid.NewGuid().ToString();
            Nodes = nodes;
        }

        public static ConnectedNodes FindNodeWithArray(ConnectedNodes connectedNodes)
        {
            while (connectedNodes.NodeReference != null)
            { 
                connectedNodes = connectedNodes.NodeReference;
            }

            return connectedNodes;
        }
    }

    

    public static int[] SplitString(string input)
    {
        var words = input.Split(' ');
        var numbers = new int[words.Length];

        for (int i = 0; i < words.Length; i++)
        {
            numbers[i] = int.Parse(words[i]);
        }

        return numbers;
    }

}

