def check_connected(graph):
    visited = set()
    stack = [graph[0][0]]

    while stack:

        current = stack.pop()
        visited.add(current)

        for edge in graph:
            if current in edge:
                for vertex in edge:
                    if vertex not in visited and vertex != current:
                        stack.append(vertex)

    if len(visited) == len(graph):
        print("YES")
    else:
        print("NO")




def create_graph(n):
    graph = []
    for i in range(1,n+1):
        if i+i > n:
            graph.append([i, i + i - n])
        else:
            graph.append([i, i+i])

    return graph
n = 8

graph = create_graph(n)
check_connected(graph)
#
# def check_connectivity(graph):
#     visited = [False] * (len(graph) + 1)
#     queue = []
#     queue.append(1)
#     visited[1] = True
#     while queue:
#         node = queue.pop(0)
#         for i in graph[node]:
#             if not visited[i]:
#                 visited[i] = True
#                 queue.append(i)
#     if all(visited):
#         print("YES")
#     else:
#         print("NO")
#         first_edge = None
#         second_edge = None
#         for i in range(1, len(graph) + 1):
#             for j in graph[i]:
#                 if not visited[i] and not visited[j]:
#                     if first_edge is None:
#                         first_edge = (i, j)
#                     elif second_edge is None:
#                         second_edge = (i, j)
#                     if first_edge is not None and second_edge is not None:
#                         break
#             if first_edge is not None and second_edge is not None:
#                 break
#         if first_edge is not None:
#             print("edge {} and".format(first_edge[0]), end = " ")
#         if second_edge is not None:
#             print("edge {} are not connected".format(second_edge[0]))
#
#
#
#
#
#
#
# n = 8
# G = create_graph(n)
# check_connectivity(G)
