#include <bits/stdc++.h>
using namespace std;

struct Point
{
    int x, y;    
};
istream& operator>>(istream& in, Point& p)
{
    in>>p.x>>p.y;
    return in;
}

struct Rectangle
{
    Point e1, e2;
};
istream& operator>>(istream& in, Rectangle& r)
{
    in>>r.e1>>r.e2;
    return in;
}

bool sections_intersect(int x1, int x2, int x3, int x4)
{
    return !((x4<x1)||(x3>x2));
}
bool intersects(const Rectangle& r1, const Rectangle& r2)
{
    return sections_intersect(r1.e1.x, r1.e2.x, r2.e1.x, r2.e2.x) &&
    sections_intersect(r1.e1.y, r1.e2.y, r2.e1.y, r2.e2.y);
}

using Component = list<int>;
Rectangle rectangles[5000];
list<Component> components;
int n, x, y;

void make_components()
{
    bool new_component=1, already_in_component=0;
    list<Component>::iterator component;
    for(int i=0; i<n; ++i)
    {
        for(list<Component>::iterator j=components.begin(); j!=components.end(); ++j) {
            for(Component::iterator k=j->begin(); k!=j->end(); ++k) {
                if(intersects(rectangles[i], rectangles[*k])) {
                    new_component=0;
                    if(!already_in_component) {
                        j->push_back(i);
                        already_in_component=1;
                        component=j;
                    }
                    else {
                        if(component!=j) {
                            component->splice(component->end(), *j);
                            components.erase(j);
                        }
                    }
                }
            }
        }
        if(new_component)
        {
            components.push_back(Component(1, i));    
        }
        new_component=1, already_in_component=0;
    }
}

bool can()
{
    bool up, down, left, right;
    for(list<Component>::iterator j=components.begin(); j!=components.end(); ++j)
    {
        up=0, down=0, left=0, right=0;
        for(Component::iterator k=j->begin(); k!=j->end(); ++k)
        {
            if(rectangles[*k].e1.x==0) left=1;
            if(rectangles[*k].e1.y==0) up=1;
            if(rectangles[*k].e2.x==x) right=1;
            if(rectangles[*k].e2.y==y) down=1;               
        }
        if((up && down) || (up && left) || (right && down) || (right && left)) return 0;
    }
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>x>>y>>n;
    for(int i=0; i<n; ++i) cin>>rectangles[i];
    /*make_components();
    if(can()) cout<<"YES";
    else cout<<"NO";*/
}
